﻿using Syncfusion.SfGauge.XForms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xamarin.Forms;

namespace AndroidGaugeTest
{
	public class App
	{
		public static Page GetMainPage()
		{
			return new ContentPage
			{
				Padding = new Thickness(20),
				BackgroundColor = Color.White,
				Content = new StackLayout()
				{
					Children =
					{
						CheckLabel(),
						MyGauge()
					}
				}
			};
		}

		private static SfCircularGauge MyGauge()
		{
			SfCircularGauge g = new SfCircularGauge()
			{

			};

			var scale = new Scale
			{
				StartValue = 0,
				EndValue = 3000,
				StartAngle = 180,
				SweepAngle = 180,
				RimThickness = 100,
				RimColor = Color.FromHex("888888"),
				ShowTicks = false,
				ShowLabels = false
			};

			var pointer = new RangePointer
			{
				Color = Color.Green,
				Thickness = 100,
				BindingContext = TestViewModel.Instance
			};

			pointer.SetBinding<TestViewModel>(RangePointer.ValueProperty, m => m.Power);

			scale.Pointers.Add(pointer);

			g.Scales.Add(scale);

			return g;
		}

		private static Label CheckLabel()
		{
			Label l = new Label()
			{
				HorizontalOptions = LayoutOptions.CenterAndExpand,
				BindingContext = TestViewModel.Instance,
				Font = Font.SystemFontOfSize(22),
				TextColor = Color.Black
			};
			l.SetBinding<TestViewModel>(Label.TextProperty, m => m.Power, BindingMode.Default, null, "{0:N0}");
			return l;
		}

	}
}
