﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace AndroidGaugeTest
{
	public class TestViewModel : INotifyPropertyChanged
	{
		private static readonly Lazy<TestViewModel> _instance = new Lazy<TestViewModel>(() => new TestViewModel());
		public static TestViewModel Instance
		{
			get { return _instance.Value; }
		}

		private double _power = 1000;
		public double Power
		{
			set
			{
				if (_power != value)
				{
					_power = value;
					OnPropertyChanged();
				}
			}
			get
			{
				return _power;
			}
		}

		public event PropertyChangedEventHandler PropertyChanged;

		public TestViewModel()
		{
			Random rnd = new Random();

			Task.Run(async () =>
			{
				while (true)
				{
					await Task.Delay(2000);

					double val = rnd.NextDouble() * 2000 + 1000;

					Device.BeginInvokeOnMainThread(() =>
					{
						this.Power = val;
					});

				}
			});
		}

		private void OnPropertyChanged([CallerMemberName]string Membername = null)
		{
			var handler = PropertyChanged;
			if (handler != null)
			{
				PropertyChangedEventArgs pce = new PropertyChangedEventArgs(Membername);
				handler(this, pce);
			}
		}

	}
}
